package com.fh3jyun.appbasic;

import org.apache.cordova.CallbackContext;
import org.apache.cordova.CordovaPlugin;
import org.apache.cordova.CordovaActivity;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.content.pm.ActivityInfo;
import android.content.res.Configuration;

import com.alivc.player.AccessKey;

import com.alivc.player.AliVcMediaPlayer;
import com.alivc.player.MediaPlayer;

import com.fh3jyun.appbasic.NetWatchdog;

import android.content.Context;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageManager;
import android.graphics.Color;
import android.graphics.Point;
import android.util.Log;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.app.Activity;

import android.os.Bundle;
import android.widget.Toast;
import android.view.Window;
import android.view.WindowManager;
import android.os.Handler;
import java.lang.Thread;

import android.Manifest;
import android.content.Intent;
import android.os.Build;
import android.text.TextUtils;

import android.support.v7.app.AlertDialog;
import android.view.LayoutInflater;


public class PlayerPlugin extends CordovaPlugin {

	private static String TAG = "PlayerPlugin";

	private CallbackContext callbackContext = null;
	public RelativeLayout relLayout = null;
	public SurfaceView mSurfaceView = null;
	private SurfaceHolder mSurfaceHolder = null;
	// private MainActivity mainActivity;
	private CordovaActivity mainActivity;
	private TextView textView = null;

	public AliVcMediaPlayer mPlayer = null;
	public String url = null;

	private NetWatchdog netWatchdog;

	@Override
	public boolean execute(String action, JSONArray args, CallbackContext callbackContext) throws JSONException {
		this.callbackContext = callbackContext;

		// 判断是否显示播放器界面
		if (action.equals("playVideo")) {
			mainActivity = (CordovaActivity) cordova.getActivity();
			// requestWindowFeature(Window.FEATURE_NO_TITLE);
			try {
				ApplicationInfo appInfo = mainActivity.getPackageManager().getApplicationInfo(mainActivity.getPackageName(), PackageManager.GET_META_DATA);
				final String accessKeyId = "LTAILpjhIf9ytxql";// appInfo.metaData.getString("accessKeyId");
				final String accessKeySecret = "ZL2SHg6S6YjLrmHWjmyFb1CoNYDgMb";// appInfo.metaData.getString("accessKeySecret");
				final String businessId = "video_live";// appInfo.metaData.getString("businessId");
				
				
				AliVcMediaPlayer.init(mainActivity.getApplicationContext());
				JSONObject jsonObject = args.getJSONObject(0);
				url = jsonObject.getString("url");
				int videoTop = jsonObject.getInt("top");
				// videoWidth = jsonObject.getInt("width");
				// videoHeight = jsonObject.getInt("height");
				// 显示或者隐藏

				playVideo(videoTop);
			} catch (Throwable t) {
				callbackContext.error(t.getMessage().toString());
				return false;
			}
			return true;
		} else if (action.equals("destroy")) {
			// 销毁
			destroy();
			return true;
		}
		return false;
	}

	private boolean playVideo(final int top) {
		try {
			mainActivity.runOnUiThread(new Runnable() {
				@Override
				public void run() {
					if (mPlayer == null) {
						// createView(top);
						createView_portrait(top);
					} else {
						//mPlayer.releaseVideoSurface();

						mPlayer.stop();
						mPlayer.destroy();
						mPlayer = null;
						startToPlay();
					}
				}
			});
			return true;
		} catch (Exception e) {
			callbackContext.error(getStringValue("errorHint") + ":" + e);
			return false;
		}
	}

	private void destroy() {
		if (mainActivity != null) {
			mainActivity.runOnUiThread(new Runnable() {
				@Override
				public void run() {
					if (mPlayer != null) {
						//mPlayer.releaseVideoSurface();
						mPlayer.stop();
						mPlayer.destroy();
						mPlayer = null;
					}
					if (mSurfaceView != null) {
						mSurfaceView.setVisibility(View.GONE);
						mSurfaceView = null;
					}
					if (relLayout != null) {
						relLayout.setVisibility(View.GONE);
						relLayout = null;
					}
				}
			});
		}
	}

	private void changeOrientation() {
		int orientation = mainActivity.getResources().getConfiguration().orientation;
		int portrait = Configuration.ORIENTATION_PORTRAIT;
		int ORIENTATION_LANDSCAPE = ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE;
		int ORIENTATION_PORTRAIT = ActivityInfo.SCREEN_ORIENTATION_PORTRAIT;
		if (orientation == portrait) {
			mainActivity.setRequestedOrientation(ORIENTATION_LANDSCAPE);
		}
	}

	private void createView_portrait(int top) {

		mainActivity.getWindow().clearFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);

		destroy();

		// 线性布局
		LinearLayout linearLayout = new LinearLayout(mainActivity);
		relLayout = new RelativeLayout(mainActivity);

		LinearLayout.LayoutParams wrapParam = new LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, LinearLayout.LayoutParams.MATCH_PARENT);
		wrapParam.setMargins(5, top, 5, 5);
		linearLayout.removeAllViews();
		linearLayout.addView(relLayout, wrapParam);

		RelativeLayout.LayoutParams playParam = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.MATCH_PARENT, RelativeLayout.LayoutParams.WRAP_CONTENT);
		// 设置放在父控件中间
		playParam.addRule(RelativeLayout.CENTER_IN_PARENT, RelativeLayout.TRUE);
		// 创建一个videoView==============用surfaceview代替
		mSurfaceView = new SurfaceView(mainActivity);
		mSurfaceView.setZOrderOnTop(false);

		// mSurfaceView.getWindow().setBackgroundDrawable(colorDrawable);
		// 为避免重复添加,事先remove子view
		relLayout.removeAllViews();
		relLayout.addView(mSurfaceView, playParam);

		// 显示正在加载
		textView = new TextView(mainActivity);
		textView.setTextSize(20);
		textView.setTextColor(Color.WHITE);
		RelativeLayout.LayoutParams msgParam = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.WRAP_CONTENT, RelativeLayout.LayoutParams.WRAP_CONTENT);
		// 设置放在父控件中间
		msgParam.addRule(RelativeLayout.CENTER_IN_PARENT, RelativeLayout.TRUE);
		relLayout.addView(textView, msgParam);

		Point deviceSize = new Point();
		mainActivity.getWindowManager().getDefaultDisplay().getSize(deviceSize);
		mainActivity.addContentView(linearLayout, new LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, deviceSize.x * 3 / 4));

		//Toast.makeText(mainActivity, "2222222222222221", Toast.LENGTH_SHORT).show();

		mSurfaceHolder = mSurfaceView.getHolder();
		mSurfaceHolder.addCallback(mSurfaceHolderCB);

		//Toast.makeText(mainActivity, "2222222222222222", Toast.LENGTH_SHORT).show();
	}

	private void createView(int top) {
		mainActivity.getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
		destroy();
		// 线性布局
		LinearLayout linearLayout = new LinearLayout(mainActivity);
		relLayout = new RelativeLayout(mainActivity);

		LinearLayout.LayoutParams wrapParam = new LinearLayout.LayoutParams(LinearLayout.LayoutParams.FILL_PARENT, LinearLayout.LayoutParams.FILL_PARENT);
		wrapParam.setMargins(0, 0, 0, 0);
		linearLayout.removeAllViews();
		linearLayout.addView(relLayout, wrapParam);

		RelativeLayout.LayoutParams playParam = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.FILL_PARENT, RelativeLayout.LayoutParams.FILL_PARENT);
		// 设置放在父控件中间
		playParam.addRule(RelativeLayout.CENTER_IN_PARENT, RelativeLayout.TRUE);
		// 创建一个videoView==============用surfaceview代替
		mSurfaceView = new SurfaceView(mainActivity);
		mSurfaceView.setZOrderOnTop(false);

		// mSurfaceView.getWindow().setBackgroundDrawable(colorDrawable);
		// 为避免重复添加,事先remove子view
		relLayout.removeAllViews();
		relLayout.addView(mSurfaceView, playParam);

		// 显示正在加载
		textView = new TextView(mainActivity);
		textView.setTextSize(20);
		textView.setTextColor(Color.WHITE);
		RelativeLayout.LayoutParams msgParam = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.WRAP_CONTENT, RelativeLayout.LayoutParams.WRAP_CONTENT);
		// 设置放在父控件中间
		msgParam.addRule(RelativeLayout.CENTER_IN_PARENT, RelativeLayout.TRUE);
		relLayout.addView(textView, msgParam);

		Point deviceSize = new Point();
		mainActivity.getWindowManager().getDefaultDisplay().getSize(deviceSize);
		mainActivity.addContentView(linearLayout, new LinearLayout.LayoutParams(LinearLayout.LayoutParams.FILL_PARENT, LinearLayout.LayoutParams.FILL_PARENT));

		mSurfaceHolder = mSurfaceView.getHolder();
		mSurfaceHolder.addCallback(mSurfaceHolderCB);
	}

	/**
	 * 屏幕旋转时调用此方法
	 */
	@Override
	public void onConfigurationChanged(Configuration newConfig) {
		super.onConfigurationChanged(newConfig);
		// newConfig.orientation获得当前屏幕状态是横向或者竖向
		// Configuration.ORIENTATION_PORTRAIT 表示竖向
		// Configuration.ORIENTATION_LANDSCAPE 表示横屏
		if (newConfig.orientation == Configuration.ORIENTATION_PORTRAIT) {
			//Toast.makeText(mainActivity, "现在是竖屏", Toast.LENGTH_SHORT).show();
			createView_portrait(120);

		}
		if (newConfig.orientation == Configuration.ORIENTATION_LANDSCAPE) {
			//Toast.makeText(mainActivity, "现在是横屏", Toast.LENGTH_SHORT).show();
			createView(0);
		}
	}

	private SurfaceHolder.Callback mSurfaceHolderCB = new SurfaceHolder.Callback() {
		@SuppressWarnings("deprecation")
		public void surfaceCreated(SurfaceHolder holder) {
			holder.setType(SurfaceHolder.SURFACE_TYPE_GPU);
			holder.setKeepScreenOn(true);
			// 重点:
			if (mPlayer != null) {
				// 对于从后台切换到前台,需要重设surface;部分手机锁屏也会做前后台切换的处理
				mPlayer.setVideoSurface(mSurfaceView.getHolder().getSurface());
			} else {
				// 创建并启动播放器
				startToPlay();
			}
		}

		public void surfaceChanged(SurfaceHolder holder, int format, int w, int h) {
			if (mPlayer != null)
				mPlayer.setSurfaceChanged();
		}

		public void surfaceDestroyed(SurfaceHolder holder) {
			if (mPlayer != null) {
				//mPlayer.releaseVideoSurface();
			}
		}
	};

	private boolean startToPlay() {
		try {
			if (mPlayer == null) {
				// 初始化播放器
				mPlayer = new AliVcMediaPlayer(mainActivity, mSurfaceView);

				mPlayer.setPreparedListener(new MyPreparedListener());
				mPlayer.setFrameInfoListener(new MyFrameInfoListener());
				mPlayer.setErrorListener(new MyErrorListener());
				mPlayer.setCompletedListener(new MyPlayerCompletedListener());
				mPlayer.setSeekCompleteListener(new MySeekCompleteListener());
				mPlayer.setStoppedListener(new MyStoppedListener());
				//mPlayer.enableNativeLog();

			}

			//netWatchdog = new NetWatchdog(mainActivity);
			//netWatchdog.setNetChangeListener(new MyNetChangeListener());
			//netWatchdog.startWatch();

			mPlayer.prepareAndPlay(url);
			
			//start();

		} catch (Exception e) {

			//Toast.makeText(mainActivity, e.getMessage().toString(), Toast.LENGTH_SHORT).show();

			//callbackContext.error(e.getMessage().toString());
		}
		return true;
	}

	private static class MyNetChangeListener implements NetWatchdog.NetChangeListener {
		@Override
		public void onWifiTo4G() {
				onWifiTo4G();
		}

		@Override
		public void on4GToWifi() {
				on4GToWifi();
		}

		@Override
		public void onNetDisconnected() {
				onNetDisconnected();
		}
	}

	private void onWifiTo4G() {
		/*if (mPlayer.isPlaying()) {
			pause();
		}
		AlertDialog.Builder alertDialog = new AlertDialog.Builder(LiveModeActivity.this);
		alertDialog.setTitle(getString(R.string.net_change_to_4g));
		alertDialog.setMessage(getString(R.string.net_change_to_continue));
		alertDialog.setPositiveButton(getString(R.string.ok), new DialogInterface.OnClickListener() {
			@Override
			public void onClick(DialogInterface dialogInterface, int i) {
				replay();
			}
		});
		alertDialog.setNegativeButton(getString(R.string.no), null);
		AlertDialog alert = alertDialog.create();
		alert.show();

		Toast.makeText(mainActivity, R.string.net_change_to_4g, Toast.LENGTH_SHORT).show();*/
		
		//Toast.makeText(mainActivity, "onWifiTo4G", Toast.LENGTH_SHORT).show();
	}

	private void on4GToWifi() {
		/*Toast.makeText(mainActivity, R.string.net_change_to_wifi, Toast.LENGTH_SHORT).show();*/
		//Toast.makeText(mainActivity, "on4GToWifi", Toast.LENGTH_SHORT).show();
	}

	private void onNetDisconnected() {
		/*Toast.makeText(mainActivity, R.string.net_disconnect, Toast.LENGTH_SHORT).show();*/
		//Toast.makeText(mainActivity, "onNetDisconnected", Toast.LENGTH_SHORT).show();
	}
	
	
	private void start() {

        if (mPlayer != null) {
            //mPlayer.prepareAndPlay(url);
        	mPlayer.play();
        }
    }

    private void pause() {
        if (mPlayer != null) {
            mPlayer.pause();
        }
    }

    private void stop() {
        if (mPlayer != null) {
            mPlayer.stop();
        }
    }

    private void resume() {
        if (mPlayer != null && mPlayer.isPlaying()) {
            mPlayer.play();
        }
    }

    private void destroy11() {
        if (mPlayer != null) {
            mPlayer.stop();
            mPlayer.destroy();
        }
    }

    private void replay() {
        stop();
        start();
    }

	private static class MyPreparedListener implements MediaPlayer.MediaPlayerPreparedListener {
		@Override
		public void onPrepared() {
		}

	}

	private static class MyFrameInfoListener implements com.alivc.player.MediaPlayer.MediaPlayerFrameInfoListener {
		@Override
		public void onFrameInfoListener() {
		}
	}

	private static class MyErrorListener implements MediaPlayer.MediaPlayerErrorListener {
		@Override
		public void onError(int i, String s) {
		}
	}

	private static class MyPlayerCompletedListener implements MediaPlayer.MediaPlayerCompletedListener {
		@Override
		public void onCompleted() {
		}

	}

	private static class MySeekCompleteListener implements MediaPlayer.MediaPlayerSeekCompleteListener {
		@Override
		public void onSeekCompleted() {
		}
	}

	private static class MyStoppedListener implements MediaPlayer.MediaPlayerStoppedListener {
		@Override
		public void onStopped() {
		}
	}


	private String getStringValue(String key) {
		// 初始化
		try {
			int id = cordova.getActivity().getResources().getIdentifier(key, "string", cordova.getActivity().getPackageName());
			return cordova.getActivity().getString(id);
		} catch (Exception e) {
			return "";
		}
	}
}
